//
// Charcoal vertex shader
//

varying	vec3		color;

uniform sampler2D	randomTex;
uniform sampler2D	cetTex;
uniform sampler2D	paperTex;

void main (void)
{
	vec4	random   = texture2D ( randomTex,  gl_TexCoord [0].xy );
	vec3	contrast = texture2D ( cetTex, vec2 ( random.x, color.x ) ).rgb;
	vec3	smudge   = 0.5 * (contrast + color);	
	vec3	paper    = texture2D ( paperTex, gl_FragCoord.xy / 512.0 ).rgb;

	gl_FragColor.rgb = contrast + vec3 ( 1.0 ) - paper;
	gl_FragColor.a   = 1.0;
}

