//
// Charcoal vertex shader
//

uniform	vec3	lightPos;
uniform	vec3	eyePos;
varying	vec3	color;

void main(void)
{
	const	vec3	ambient   = vec3 ( 0.0 );
	const	vec3	diffuse   = vec3 ( 1.0, 1.0, 1.0 );
	const	vec3	luminance = vec3 ( 0.3, 0.59, 0.11 );
	
	vec3 p = vec3 ( gl_ModelViewMatrix * gl_Vertex );
	vec3 l = normalize ( lightPos - p );
	vec3 n = normalize ( gl_NormalMatrix * gl_Normal );

											// compute illumination
	color = ambient + diffuse * max ( dot ( n, l ), 0.0 );
	
											// apply CEO
	color = vec3 ( pow ( clamp ( dot ( color, luminance ), 0.0, 1.0 ), 3.5 ) ); 
											
	gl_Position     = gl_ModelViewProjectionMatrix * gl_Vertex;
	gl_TexCoord [0] = gl_MultiTexCoord0;
}

