//
// Mosaic as a postprocessing effect
//

uniform	sampler2D	mainTex;
uniform sampler2D	brushTex;

void main (void)
{
	const	vec3	luminance = vec3 ( 0.3, 0.59, 0.11 );

	vec3	color = texture2D ( mainTex,  gl_TexCoord [0].xy, 2.0 );	// have to pass coordinate of source point sprite
																		// to blur image a bit
	vec3	brush = texture2D ( brushTex, gl_TexCoord [1].xy ).rgb;

	gl_FragColor = vec4 ( color.rgb * vec3 ( dot ( brush, luminance ) ), 1.0 );
}
